awoo's blog

By awoo, history, 11 hours ago, translation, In English

2043A - Coin Transformation

Idea: BledDest

Tutorial
Solution (BledDest)

2043B - Digits

Idea: AcidWrongGod

Tutorial
Solution (BledDest)

2043C - Sums on Segments

Idea: Ferume

Tutorial
Solution (awoo)

2043D - Problem about GCD

Idea: Ferume

Tutorial
Solution (BledDest)

2043E - Matrix Transformation

Idea: Ferume

Tutorial
Solution (BledDest)

2043F - Nim

Idea: Ferume

Tutorial
Solution (awoo)

2043G - Problem with Queries

Idea: Ferume

Tutorial
  • Vote: I like it
  • +36
  • Vote: I do not like it

»
11 hours ago, # |
  Vote: I like it -17 Vote: I do not like it

first

»
11 hours ago, # |
  Vote: I like it 0 Vote: I do not like it

second

»
11 hours ago, # |
  Vote: I like it +4 Vote: I do not like it

Problem F can also be solved using divide and conquer.

If we are at range [L, R] with the recursion, let mid = (L + R) / 2. We will answer all queries [ql, qr] where ql <= mid < qr.

This can be easily done using 2 knapsacks, one from mid to L and one from mid+1 to R.

Submission link

»
11 hours ago, # |
  Vote: I like it 0 Vote: I do not like it

I didn't found divisibility rule for 7 anywhere how it was figured out in problem B??

  • »
    »
    10 hours ago, # ^ |
      Vote: I like it +3 Vote: I do not like it
  • »
    »
    10 hours ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    as d can be taken common everytime so you can just write as d*(1111.....) now if d is 7. It is always true that given number is divisible by 7 if not than you can check what is the minimum number of one is required to make it divisible by 7. I got that minimum 6 1's should be present so if n>=3 it is divisible by 7 regardless the value of d

  • »
    »
    26 minutes ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    there are a lot of different rules out there the one you need here is that: if the alternating sum and difference of 3 digits from left to right is divisible by 7 then the number will be divisible by 7 for example: 12,332,455 :- value = (4+5+5)-(3+3+2)+(1+2) = 9 ; which is not divisible by 7 hence number is not divisible by 7.

    for n!>=6 (i.e. n>=3, n!=6*k) number of digits will be multiple of 3 and 2, hence you always have even pair of alternating sum of 3 digits hence above value will always be 0 hence divisible by 7.

»
11 hours ago, # |
Rev. 2   Vote: I like it 0 Vote: I do not like it

i want to explain easier approach of E but bad englis, you can check my sub tho

  • »
    »
    10 hours ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    read your solution, can you tell me a proof for why it was enough to check for only 10 numbers left and right?

    • »
      »
      »
      9 hours ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      i guessed it honestly. i dont have a good proof for that. i statistically thought a prime number would occur once every 10 numbers and applied that. but max difference between primes <= 1e9 is ~200 so l + 200 and r — 200 would be good bound to find a prime number.

»
10 hours ago, # |
  Vote: I like it 0 Vote: I do not like it

There is still a greedy way to pass tests in E by applying an operation when needed and running it min(n,m) times. Meaning complexity would be $$$O(tnm*min(n,m))$$$

Submission

I would like to either see it hacked or disproven. Unless that is correct which i highly doubt as I wasn't able to prove it.

  • »
    »
    10 hours ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    I solved exactly like this, would be very nice if someone prove or hack it

  • »
    »
    8 hours ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    I know right? I just solved it performing necessary operations on each row and column once, and i repeat it 100 times. It passes all the tests.

  • »
    »
    5 hours ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    $$$min(n,m)$$$ seems logical, because you need space for a cycle. Let $$$min(m,n)=n$$$. Proof may be something like when $$$n=1$$$ it's obviously correct. For 2, maximum cycle is when setting some bits in one row breaks in another, and vice versa. For 3 same thing is for triangle, and so on.

    When in doubt detect cycle using hash: 298400755

»
10 hours ago, # |
  Vote: I like it 0 Vote: I do not like it

C was really interesting! Hopefully will be able to solve C in div 2 next time.

»
10 hours ago, # |
  Vote: I like it 0 Vote: I do not like it

11?

»
10 hours ago, # |
  Vote: I like it 0 Vote: I do not like it

For the problem E tutorial, can anyone help me with the bound on the number of edges in the operation graph?

I wrote a brute-force solution that passed with complexity $$$O(tnm*min(n,m)*\log{A})$$$.

»
9 hours ago, # |
Rev. 2   Vote: I like it 0 Vote: I do not like it

In 2043B - Digits definition of first way, I think there is a mistake.

(123 − 456 + 9) is -324, and it's not divisible by 7 because -324 % 7 is 5.

I think it must be (569 − 234 + 1). {(569−234+1) = 336 % 7 = 0}

awoo

  • »
    »
    8 hours ago, # ^ |
    Rev. 2   Vote: I like it +3 Vote: I do not like it

    The original number is 1234569, we take blocks of 3 digits from right to left.

    569 - 234 + 1 = 366 ≡ 0 (mod 7).

  • »
    »
    6 hours ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Yeah, this was an error, thank you. Will be fixed in a couple of minutes

»
9 hours ago, # |
  Vote: I like it 0 Vote: I do not like it

2043F - Nim. Nah, I've forgotten the dp way for finding xor = 0, and I wrote meet in the middle, because we can remove all the elements except for 7. So I can test if I can leave exactly 1 element, 2 elements, ..., 6 elements. And to check if I can leave 6 elements, I can check a pair of (3, 3) elements. 298456482

  • »
    »
    7 hours ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    can you explain this one bro? How did you arrive at this "because we can remove all the elements except for 7"?

    • »
      »
      »
      7 hours ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      Because the size of the vector basis can't be more than 6 because $$$a_i \le 50$$$.

»
7 hours ago, # |
  Vote: I like it 0 Vote: I do not like it

F is a cool problem

»
6 hours ago, # |
Rev. 2   Vote: I like it 0 Vote: I do not like it

For problem D: "This should mean that it is divisible by at least 15 primes which are greater than 37" Why? This one number can fix many pairs, by it, and the numbers it pairs with, all having 41 (say) as a prime divisor. The argument can be made to work, but what is written is I think wrong. Please clarify.

  • »
    »
    6 hours ago, # ^ |
    Rev. 2   Vote: I like it +3 Vote: I do not like it

    If a prime is greater than the length of the segment (for example, $$$30$$$), there is at most one number in the segment that is divisible by it. So, if a number appears in $$$15$$$ or more pairs that are not fixed by primes less than $$$30$$$, every such pair should be "fixed" by a separate prime.

»
6 hours ago, # |
Rev. 2   Vote: I like it 0 Vote: I do not like it

awoo Ferume BledDest

In problem G you said that : Unfortunately, it is practically impossible to fit this within time limits, so let's try to improve the solution.

But when I submit this solution with B=1300, it has got an accepted with time 7700ms

https://codeforces.net/contest/2043/submission/298343933

If it should get a TLE, try to add some big tests that makes B=1300 worst.

  • »
    »
    5 hours ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Hacked

    I guess it's quite difficult to make a set of test data that TLEs all possible choices of $$$B$$$, so $$$O((n + q) n^{\frac{2}{3}})$$$ solutions can get accepted, although they can then be hacked (including all but one of the in-contest submissions lol)

    • »
      »
      »
      5 hours ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      The lucky man who chooses 1300 in the in-contest :))

      Thx for the hack :)

»
4 hours ago, # |
  Vote: I like it 0 Vote: I do not like it

For problem $$$D$$$, I miscalculated that if we consider all possible pairs of integers from intervals $$$[l,l+10)$$$ and $$$(r−10,r]$$$, we will find at least one coprime pair. But, the problem passed the system tests. Can anyone prove it or uphack the solution?
Submission — 298478051

»
87 minutes ago, # |
  Vote: I like it 0 Vote: I do not like it

can someone please explain why it is giving tle[submission:https://codeforces.net/contest/2043/submission/298310318]

»
58 minutes ago, # |
  Vote: I like it 0 Vote: I do not like it

Nobody has mentioned the following method for Problem E, which was much more intuitive than the graph method for me:

For each binary matrix B, the final move must result in a column of all 1s or a row of all 0s. Therefore, we can go backwards from B to A and ignore all rows and columns once we know there is a later operation that can set it to be accurate in B. This can be done simply by keeping a counter and sum for each row/column.

Submission here: https://codeforces.net/contest/2043/submission/298482881

»
24 minutes ago, # |
  Vote: I like it 0 Vote: I do not like it

I am facing a lot difficulty in understanding problem D.

can someone explain it to me.

»
8 minutes ago, # |
Rev. 2   Vote: I like it 0 Vote: I do not like it

Problem G appeared in a contest on Luogu 5 years ago, here is the link: P6019 [Ynoi2010] Brodal queue

The problem statement on Luogu is:

1 l r x: for( i = l ; i <= r ; i++ ) a[i] = x;

2 l r: count the number of (i,j) that l<=i<j<=r and a[i]==a[j]